﻿using System.Diagnostics;
using System.Threading;
using System.Windows.Media;
using System.Xml;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using Clio.Utilities;
using System;
using System.Collections.Generic;
using System.IO;
using System.Configuration;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows.Forms;
using ff14bot.RemoteWindows;
using TreeSharp;

using Action = TreeSharp.Action;
using ff14bot.AClasses;

namespace Chocobot
{
    public class Chocobot : BotBase
    {
        private Composite _root;
        private ChocobotForm _settings;
        public static ChocobotSettings Settings = ChocobotSettings.Instance;
        public int Status = 0;

        #region Constants
        public Vector3 NpcLocation = new Vector3(-1.537905f, -2.145767E-06f, -63.7381f);
        public uint NpcId = 1010464;

        public Vector3 TransportNpcLocation = new Vector3(-84.45868f, 3.814697E-06f, 29.06836f);
        public uint TransportNpcId = 1011044;
        #endregion

        public override string Name
        {
            get { return "Chocobot"; }
        }

        public override bool IsAutonomous
        {
            get { return true; }
        }

        public static Version Version = new Version(1, 0, 0);

        public override void OnButtonPress()
        {
            if (_settings == null || _settings.IsDisposed)
                _settings = new ChocobotForm();
            try
            {
                _settings.Show();
                _settings.Activate();
            }
            catch (ArgumentOutOfRangeException ee)
            {
            }
        }

        public override void Start()
        {
            Navigator.PlayerMover = new SlideMover();
            Navigator.NavigationProvider = new GaiaNavigator();

            GamelogManager.MessageRecevied += RecieveMessage;

            Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Starting Chocobot");
        }

        private void RecieveMessage(object sender, ChatEventArgs e)
        {
            if (e.ChatLogEntry.MessageType == (MessageType)2238 && e.ChatLogEntry.Contents.Contains("You obtain") && e.ChatLogEntry.Contents.Contains("MGP"))
            {
                var mgp = e.ChatLogEntry.Contents.Substring(11, (e.ChatLogEntry.Contents.Length - 16));
                Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Obtained " + mgp + " MGP!");
            }
        }

        public override void Stop()
        {
            var gaiaNavigator = Navigator.NavigationProvider as GaiaNavigator;
            if (gaiaNavigator != null)
                gaiaNavigator.Dispose();
            Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Stopping Chocobot");
            Status = 0;
        }

        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }

        public override bool RequiresProfile
        {
            get { return false; }
        }

        public override bool WantButton
        {
            get { return true; }
        }

        public bool InRace
        {
            get
            {
                // 391 - Tranquil Paths
                // 390 - Sagolii Road
                // 389 - Costa del Sol
                return WorldManager.ZoneId == 390 || WorldManager.ZoneId == 389 || WorldManager.ZoneId == 391;
            }
        }

        #region Icky Stuff
        [DllImport("user32.dll", SetLastError = true)]
        static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);

        public const int KEY_DOWN_EVENT = 0x0001;
        public const int KEY_UP_EVENT = 0x0002;
        public const int W_KEY = 0x57;
        public const int D_KEY = 0x44;
        public const int A_KEY = 0x41;
        public const int ACT_KEY1 = 0x31;
        public const int ACT_KEY2 = 0x32;
        public const int ACT_KEY3 = 0x33;
        #endregion

        public override Composite Root
        {
            get
            {
                return _root ?? (_root =
                    new PrioritySelector(
                        new Decorator(r => RaceChocoboResult.IsOpen,
                            new Sequence(
                                new Sleep(9, 9),
                                new Action(r =>
                                {
                                    Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Race complete, leaving race.");
                                    RaceChocoboResult.Confirm();
                                    Status = 0;
                                }),
                                new Sleep(4, 7)
                            )
                        ),
                        new Decorator(r => InRace && Settings.SendKey,
                            new Sequence(
                                new Action(r => keybd_event(ACT_KEY1, 0, KEY_DOWN_EVENT, 0)),
                                new Sleep(100),
                                new Action(r => keybd_event(ACT_KEY1, 0, KEY_UP_EVENT, 0)),
                                new Action(r => keybd_event(W_KEY, 0, KEY_DOWN_EVENT, 0)),
                                new Sleep(Settings.SprintDuration),
                                new Action(r => keybd_event(W_KEY, 0, KEY_UP_EVENT, 0)),
                                new Sleep(Settings.SprintBreak),
                                new Action(r => keybd_event(ACT_KEY2, 0, KEY_DOWN_EVENT, 0)),
                                new Action(r => keybd_event(D_KEY, 0, KEY_DOWN_EVENT, 0)),
                                new Sleep(100),
                                new Action(r => keybd_event(ACT_KEY2, 0, KEY_UP_EVENT, 0)),
                                new Action(r => keybd_event(D_KEY, 0, KEY_UP_EVENT, 0)),
                                new Action(r => keybd_event(W_KEY, 0, KEY_DOWN_EVENT, 0)),
                                new Sleep(Settings.SprintDuration),
                                new Action(r => keybd_event(W_KEY, 0, KEY_UP_EVENT, 0)),
                                new Sleep(Settings.SprintBreak),
                                new Action(r => keybd_event(ACT_KEY3, 0, KEY_DOWN_EVENT, 0)),
                                new Sleep(100),
                                new Action(r => keybd_event(ACT_KEY3, 0, KEY_UP_EVENT, 0)),
                                new Action(r => keybd_event(W_KEY, 0, KEY_DOWN_EVENT, 0)),
                                new Sleep(Settings.SprintDuration),
                                new Action(r => keybd_event(W_KEY, 0, KEY_UP_EVENT, 0)),
                                new Sleep(Settings.SprintBreak)
                            )
                        ),
                        new Decorator(r => Vector3.Distance(Core.Player.Location, NpcLocation) <= 2,
                            new PrioritySelector(
                                new Decorator(r => Talk.DialogOpen,
                                    new Action(r => Talk.Next())
                                ),
                                new Decorator(r => SelectYesno.IsOpen,
                                    new Action(r => SelectYesno.ClickYes())
                                ),
                                new Decorator(r => RaceChocoboConfirm.IsOpen,
                                    new Sequence(
                                        new Sleep(1, 2),
                                        new Action(r =>
                                        {
                                            Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Accepting race!");
                                            RaceChocoboConfirm.Confirm();
                                        })
                                    )
                                ),
                                new Decorator(r => SelectString.IsOpen,
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            if (Status == 0)
                                            {
                                                SelectString.ClickSlot(0);
                                                Status = 1;
                                            }
                                            else if (Status == 1)
                                            {
                                                if (Settings.Class == "Best")
                                                {
                                                    Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Registering for race! [Best Option]");
                                                    SelectString.ClickSlot(0);
                                                }
                                                else
                                                {
                                                    SelectString.ClickLineContains(Settings.Class);
                                                }
                                                Status = 2;
                                            }
                                            else if (Status == 2)
                                            {
                                                SelectString.ClickLineContains(Settings.Course);
                                            }
                                        }),
                                        new Sleep(1, 2)
                                    )
                                ),
                                new Decorator(r => WorldManager.ZoneId == 388 && Status == 0,
                                    new Action(r =>
                                    {
                                        Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Queuing for race...");
                                        GameObjectManager.GetObjectByNPCId(NpcId).Interact();
                                    })
                                ),
                                new ActionAlwaysSucceed()
                            )
                        ),
                        new Decorator(r => Status == 0 && WorldManager.ZoneId == 388 && Vector3.Distance(Core.Player.Location, NpcLocation) > 2,
                            CommonBehaviors.MoveAndStop(r => NpcLocation, 2f, true, "Race Chocobo Registrar")
                        ),
                        new Decorator(r => Status == 0 && WorldManager.ZoneId != 388,
                            new PrioritySelector(
                                new Decorator(r => WorldManager.ZoneId == 144,
                                    new PrioritySelector(
                                        new Decorator(r => Vector3.Distance(Core.Player.Location, TransportNpcLocation) < 2,
                                            new PrioritySelector(
                                                new Decorator(r => Talk.DialogOpen,
                                                    new Action(r => Talk.Next())
                                                ),
                                                new Decorator(r => SelectYesno.IsOpen,
                                                    new Action(r => SelectYesno.ClickYes())
                                                ),
                                                new Decorator(r => !Core.Player.HasTarget && GameObjectManager.GetObjectByNPCId(TransportNpcId) != null,
                                                    new Action(r => GameObjectManager.GetObjectByNPCId(TransportNpcId).Interact())
                                                )
                                            )
                                        ),
                                        new Decorator(r => Vector3.Distance(Core.Player.Location, TransportNpcLocation) > 2,
                                            CommonBehaviors.MoveTo(r => TransportNpcLocation)
                                        )
                                    )
                                ),
                                new Decorator(r => WorldManager.ZoneId != 144,
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            if (!WorldManager.HasAetheryteId(62))
                                            {
                                                Logging.Write(Colors.SandyBrown, "[Chocobot v" + Version.ToString() + "] Missing Gold Saucer aetheryte.");
                                                TreeRoot.Stop();
                                            }
                                            if (!Core.Player.IsCasting)
                                            {
                                                WorldManager.TeleportById(62);
                                            }
                                        }),
                                        new Sleep(9)
                                    )
                                )
                            )
                        )
                    )
                );
            }
        }
    }

    #region Window Interactions
    public class RaceChocoboConfirm
    {
        public static bool IsOpen
        {
            get
            {
                return RaptureAtkUnitManager.GetWindowByName("RaceChocoboConfirm") != null;
            }
        }

        public static void Confirm()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("RaceChocoboConfirm");
            if (window != null)
            {
                window.SendAction(1, 3, 0);
            }
        }

        public static void Withdraw()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("RaceChocoboConfirm");
            if (window != null)
            {
                window.SendAction(1, 3, 1);
            }
        }
    }

    public class RaceChocoboResult
    {
        public static bool IsOpen
        {
            get
            {
                return RaptureAtkUnitManager.GetWindowByName("RaceChocoboResult") != null;
            }
        }

        public static void Confirm()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("RaceChocoboResult");
            if (window != null)
            {
                window.SendAction(1, 3, 1);
            }
        }
    }
    #endregion
}