﻿using System.ComponentModel;
using System.Configuration;
using System.IO;
using Clio.Utilities;
using ff14bot.Helpers;
using Newtonsoft.Json;

namespace Chocobot
{
    public class ChocobotSettings : JsonSettings
    {
        [JsonIgnore]
        private static ChocobotSettings _instance;
        public static ChocobotSettings Instance { get { return _instance ?? (_instance = new ChocobotSettings("ChocobotSettings")); } }
        public ChocobotSettings(string filename) : base(Path.Combine(CharacterSettingsDirectory, "Chocobot.json")) { }

        [Setting, DefaultValue("Open")]
        public string Class { get; set; } // Maiden, R-40, or Open
        [Setting, DefaultValue("Random")]
        public string Course { get; set; }
        [Setting, DefaultValue(6000)]
        public int SprintDuration { get; set; }
        [Setting, DefaultValue(2500)]
        public int SprintBreak { get; set; }
        [Setting, DefaultValue(false)]
        public bool SendKey { get; set; }
        // Maiden: Sagolii Road, Costa del Sol, Tranquil Paths, or Random
        // R-40: Sagolii Road, Costa del Sol, Tranquil Paths, or Random
        // Open: Sagolii Road, Costa del Sol, Tranquil Paths, or Random
    }
}